<!--
 * @Descripttion: (公告/tb_notice 编辑弹窗)
 * @version: (1.0)
 * @Author: (lwh)
 * @Date: (2023-10-09)
 * @LastEditors: (lwh)
 * @LastEditTime: (2023-10-09)
-->
<template>
  <el-dialog v-model="props.modelValue" title="修改公告信息" width="900px" @closed="closeDialog" @open="openDialog">
    <el-form ref="formRef" :model="formData" :rules="rules">
      <el-row :gutter="20">





        <el-col :lg="12">
          <el-form-item :label-width="labelWidth" label="标题" prop="noticeTitle">
            <el-input v-model="formData.noticeTitle" placeholder="请输入标题" />
          </el-form-item>
        </el-col>

        <el-col :lg="24">
          <el-form-item :label-width="labelWidth" label="内容" prop="noticeContent">
            <el-input v-model="formData.noticeContent" type="textarea" :rows="5" placeholder="请输入内容" />
          </el-form-item>
        </el-col>

        <el-col :lg="12">
          <el-form-item :label-width="labelWidth" label="排序" prop="noticeSort">
            <el-input-number v-model.number="formData.noticeSort" controls-position="right" :min="0" />
          </el-form-item>
        </el-col>






      </el-row>
    </el-form>

    <template #footer>
      <div class="dialog-footer">
        <el-button type="primary" @click="handleEditClick(formRef)" :loading="loadingStatus">编辑</el-button>
        <el-button @click="handleResetClick(formRef)">重置</el-button>
      </div>
    </template>
  </el-dialog>
</template>

<script setup>
import { ElMessage } from 'element-plus'
import modal from '@/plugins/modal.js'
import { reactive, ref, watch } from "vue";
import { addOrUpdateNotice } from "@/api/business/Advertisement/Notices/notice.js";


// 打开弹窗时回调
const openDialog = async () => {

}

const formData = ref({
  ...props.data,
});
watch(props, async (v) => {
  formData.value = v.data;

});

// 业务参数

// -业务方法



// -基础参数
const props = defineProps({
  modelValue: Boolean,
  data: Object,
  done: Function,
});

const loadingStatus = ref(false)
const labelWidth = 100;
const formRef = ref();
const { proxy } = getCurrentInstance()
const emits = defineEmits(["update:modelValue"]);
const imgData = ref({
  fileDir: "Notice"
})

// 验证
const rules = reactive({
  noticeGuid: [{ required: true, message: "不能为空", trigger: "blur", type: "number" }],
  noticeTitle: [{ required: true, message: "标题不能为空", trigger: "blur" }],
  noticeContent: [{ required: true, message: "内容不能为空", trigger: "blur" }],
  noticeSort: [{ required: true, message: "排序不能为空", trigger: "blur", type: "number" }],
});

// -基础方法
// 提交
const handleEditClick = async (formEl) => {
  if (!formEl) return;
  formEl.validate(async (valid) => {
    if (!valid) {
      return;
    }
    loadingStatus.value = true


    const { code } = await addOrUpdateNotice(formData.value);
    if (code == 200) {
      modal.msgSuccess('修改成功')
      closeDialog();
      loadingStatus.value = false
    }
  });
}

const handleResetClick = async (formEl) => {
  if (!formEl) return;
  formEl.resetFields();
}
const closeDialog = () => {
  props.done();
  emits("update:modelValue", false);
};

</script>
